<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="保养计划id" prop="planId">
        <el-input v-model="formData.planId" placeholder="请输入保养计划id" />
      </el-form-item>
      <el-form-item label="保养工单id" prop="workOrderId">
        <el-input v-model="formData.workOrderId" placeholder="请输入保养工单id" />
      </el-form-item>
      <el-form-item label="设备id" prop="deviceId">
        <el-input v-model="formData.deviceId" placeholder="请输入设备id" />
      </el-form-item>
      <el-form-item label="设备资产编号" prop="deviceAssetNumber">
        <el-input v-model="formData.deviceAssetNumber" placeholder="请输入设备资产编号" />
      </el-form-item>
      <el-form-item label="设备名称" prop="deviceName">
        <el-input v-model="formData.deviceName" placeholder="请输入设备名称" />
      </el-form-item>
      <el-form-item label="设备类别" prop="deviceCategory">
        <el-input v-model="formData.deviceCategory" placeholder="请输入设备类别" />
      </el-form-item>
      <el-form-item label="设备品牌" prop="deviceBrand">
        <el-input v-model="formData.deviceBrand" placeholder="请输入设备品牌" />
      </el-form-item>
      <el-form-item label="当前运行公里数(km)" prop="runningKilometers">
        <el-input v-model="formData.runningKilometers" placeholder="请输入当前运行公里数(km)" />
      </el-form-item>
      <el-form-item label="当前运行时间(小时)" prop="runningTime">
        <el-date-picker
          v-model="formData.runningTime"
          type="date"
          value-format="x"
          placeholder="选择当前运行时间(小时)"
        />
      </el-form-item>
      <el-form-item label="自然日期(天)" prop="naturalDate">
        <el-date-picker
          v-model="formData.naturalDate"
          type="date"
          value-format="x"
          placeholder="选择自然日期(天)"
        />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input v-model="formData.sort" placeholder="请输入排序" />
      </el-form-item>
      <el-form-item label="状态 0启用  1停用" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotMainWorkOrderDetailsApi, IotMainWorkOrderDetailsVO } from '@/api/pms/iotmainworkorderdetails'

/** 保养工单明细 表单 */
defineOptions({ name: 'IotMainWorkOrderDetailsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  planId: undefined,
  workOrderId: undefined,
  deviceId: undefined,
  deviceAssetNumber: undefined,
  deviceName: undefined,
  deviceCategory: undefined,
  deviceBrand: undefined,
  runningKilometers: undefined,
  runningTime: undefined,
  naturalDate: undefined,
  remark: undefined,
  sort: undefined,
  status: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotMainWorkOrderDetailsApi.getIotMainWorkOrderDetails(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotMainWorkOrderDetailsVO
    if (formType.value === 'create') {
      await IotMainWorkOrderDetailsApi.createIotMainWorkOrderDetails(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotMainWorkOrderDetailsApi.updateIotMainWorkOrderDetails(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    planId: undefined,
    workOrderId: undefined,
    deviceId: undefined,
    deviceAssetNumber: undefined,
    deviceName: undefined,
    deviceCategory: undefined,
    deviceBrand: undefined,
    runningKilometers: undefined,
    runningTime: undefined,
    naturalDate: undefined,
    remark: undefined,
    sort: undefined,
    status: undefined,
  }
  formRef.value?.resetFields()
}
</script>